﻿//
// Count Selected Objects
//
// Version: 0.2
//
// Created by André Berg on 2008-12-16
// Copyright © 2008 Berg Media. All rights reserved.
//
// FOR LICENSE DETAILS SEE THE END OF THE SCRIPT
// 
 // This small script displays the number of selected objects,
 // including grouped items and the number of groups themselves.
// 
// Should work with Illustrator CS1/CS2/CS3/CS4 and possibly 
// earlier versions too. Tested on Mac OS X 10.5.5 (Leopard)
// and Windows Vista SP1 (32-bit).
//
// TODO:
// * Display detailed statistics of object type and distribution
// 

var scriptID = "Count Selected Objects v0.2";

if (app.documents.length > 0) {
	
	var doc = app.activeDocument;
	var numPageItems = 0;
	var numGroups = 0;

	// count page items whose selected is true
	for (i = 0; i < doc.pageItems.length; i++) {
		if (doc.pageItems[i].selected == true) {
			numPageItems += 1;
		}
	}

	// count group items whose selected is true
	for (i = 0; i < doc.groupItems.length; i++) {
		if (doc.groupItems[i].selected == true) {
			numGroups += 1;
		}
	}
	
	// subtract the group items themselves since only their contents count
	var numSelectedObjects = numPageItems - numGroups;

	if (numGroups > 0) {
		alert(scriptID + "\n" + numSelectedObjects + " " + ((numSelectedObjects == 1)?"object":"objects")  + ", " + numGroups + ((numGroups == 1)?" group":" groups") , scriptID, true);
	} else {
		alert(scriptID + "\n" + numSelectedObjects + " " + ((numSelectedObjects == 1)?"object":"objects"), scriptID, true);
	}	
} else {
	alert (scriptID + "\nError: No active document\nPlease open a document and try again", scriptID, false);
}

// License
 
// Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met: 
//
// * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer. 
// * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution. 
// * Neither the name of Berg Media nor the name of André Berg may be used to endorse or promote products derived from this software without specific prior written permission.
//
// WARRANTIES AND DISCLAIMERS
//
// THIS SOFTWARE IS PROVIDED BY ANDRÉ BERG OF BERG MEDIA (DESIGNATED FROM HEREON AS "THE AUTHOR") "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

